<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">


  <!-- Audit Trail List User Activity Dates
       ====================================
  -->


  <xsl:import href='gjsTree.xsl' />
  <xsl:include href='ServerLink.xsl' />
  <xsl:include href='gjsControlsTemplates.xsl' />


  <xsl:template name='divMainHead'>

    <table class='layoutTable' width='1000'>
    	<tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25'></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"100"'/> 
          <xsl:with-param name='caption'>Date</xsl:with-param>         
            <xsl:with-param name='selected'>descending</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"150"'/> 
          <xsl:with-param name='caption'>Number of entries</xsl:with-param>         
        </xsl:call-template>

        <td width='*'></td>
      </tr>
    </table>

  </xsl:template>


  <xsl:template name='folderRowAttributes'>
    <xsl:variable name='onfocus'>
      <xsl:text>Main.fnSetMainHead("</xsl:text>
      <xsl:value-of select='/ServerLink/@runId' />
      <xsl:text>_mainHead");</xsl:text>
    </xsl:variable>
    <xsl:attribute name='onfocus'><xsl:value-of select='$onfocus' /></xsl:attribute>
    <xsl:attribute name='onclick'><xsl:value-of select='$onfocus' /></xsl:attribute>
  </xsl:template>


  <xsl:template name='folderContent'>
    <xsl:param name='rowId'/>

    <xsl:variable name='info'><xsl:call-template name='info'/></xsl:variable>

    <!-- Icon for Object -->
    <td class='noHighlight' width='25'>
      <img
       src='vcm_folder.gif'
       title='{$info}'
       width='25'
       height='16'/>
    </td>

    <!-- date cell -->
    <td
     class='treeCell'
     gjsSort='{date/@date}'
     width='100'
     nowrap='nowrap'>
      <span
       nowrap='nowrap'
       id='{$rowId}main'
       title='{$info}'
       gjsIconId='{$rowId}icon'
       gjsItem='{date/@date}'
       gjsParentId='{/ServerLink/Rows/@parentId}'
       gjsPtext='{date/@ptext}'>
        <xsl:call-template name='gjs:formatDate'>
          <xsl:with-param name='locale' select='/ServerLink/user/@locale'/>
          <xsl:with-param name='date' select='date/@date'/>
        </xsl:call-template>
      </span>
    </td>

    <!-- count cell -->
    <td
     class='treeCell'
     gjsSort='{date/@count}'
     width='100'>
      <span nowrap='nowrap'>
        <xsl:value-of select='date/@count'/>
        <xsl:text> entries</xsl:text>    
      </span>
    </td>
    
  </xsl:template>


  <!-- Tool tip -->
  <xsl:template name='info'>
    <xsl:text>Audit Trail for </xsl:text>
    <xsl:value-of select='/ServerLink/Context/user/@user' />
    <xsl:text> on </xsl:text>
    <xsl:call-template name='gjs:formatDate'>
      <xsl:with-param name='locale' select='/ServerLink/user/@locale'/>
      <xsl:with-param name='date' select='date/@date'/>
    </xsl:call-template>
  </xsl:template>


  <!-- Sub-folder method -->
  <xsl:template name='subFolderMethod'>
    <xsl:text>AuditTrail.fnListUserDateAudit</xsl:text>
  </xsl:template>


  <!-- Sub-folder arguments -->
  <xsl:template name='subFolderArguments'>
    <xsl:param name='rowId'/>

    <xsl:text>"</xsl:text>  <xsl:value-of select='$rowId'/>  <xsl:text>main"</xsl:text>
    <xsl:text>+delimiter+"</xsl:text>  <xsl:value-of select='/ServerLink/Context/user/@user'/>  <xsl:text>"</xsl:text>
    <xsl:text>+delimiter+"</xsl:text>  <xsl:value-of select='date/@date'/>  <xsl:text>"</xsl:text>
    <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>

  </xsl:template>


</xsl:stylesheet>
