<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="compTypeSet"/>
</xsl:template>

<xsl:template match="compTypeSet">
  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='../parameters/@features &lt; 4'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

<gjs:form
 title='Component Type Settings'
 jsFile='vcset74.js'
 onload='frmMain.setReadOnly.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 print='{/Form/@print}'
 delete='no'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Configurable settings for component types.
    <xsl:if test='$readonly=1'>
      NOTE: Callouts are not available on your edition of Deltanji.
    </xsl:if>
  </gjs:information>

<div id='divCompTypeSet' class='visible' style='min-height: 200px'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='250'/>
    <gjs:column width='270'/>
  </gjs:columnWidths>

  <gjs:fields>

    <xsl:apply-templates select="/Form/compTypeSet/checkbox" mode='grid'>
                <xsl:with-param name='value'/>
		<xsl:with-param name='name'/>
		<xsl:with-param name='label'/>
              </xsl:apply-templates>

    <tr><td height='16'></td></tr>

    <tr>
     <td colspan='2'>
      <label><b>INT or R (M Routine) Component Callouts</b></label>
     </td>
    </tr>

    <gjs:input
     id='calloutRS'
     size='45'
     maxlength='2000'
     accesskey='V'
     value='{@calloutRS}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On sa<u>v</u>e (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='calloutRD'
     accesskey='L'
     size='45'
     maxlength='2000'
     value='{@calloutRD}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On de<u>l</u>ete (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='routineComments'
     accesskey='G'
     size='45'
     maxlength='2000'
     value='{@routineComments}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>Comment line <u>g</u>enerator (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>

    <tr>
     <td colspan='2'>
      <label><b>MAC (Macro Routine) Component Callouts</b></label>
     </td>
    </tr>

    <gjs:input
     id='macSave'
     size='45'
     maxlength='2000'
     accesskey='V'
     value='{@macSave}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On sa<u>v</u>e (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='macDelete'
     accesskey='L'
     size='45'
     maxlength='2000'
     value='{@macDelete}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On de<u>l</u>ete (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='macComments'
     accesskey='G'
     size='45'
     maxlength='2000'
     value='{@macComments}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>Comment line <u>g</u>enerator (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <tr><td height='16'></td></tr>

    <tr>
     <td colspan='2'>
      <label><b>INC (Include File) Component Callouts</b></label>
     </td>
    </tr>

    <gjs:input
     id='incSave'
     size='45'
     maxlength='2000'
     accesskey='V'
     value='{@incSave}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On sa<u>v</u>e (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='incDelete'
     accesskey='L'
     size='45'
     maxlength='2000'
     value='{@incDelete}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>On de<u>l</u>ete (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>

    <gjs:input
     id='incComments'
     accesskey='G'
     size='45'
     maxlength='2000'
     value='{@incComments}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>Comment line <u>g</u>enerator (routine call)</label>
     <hint>Enter a value</hint>
    </gjs:input>
  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

<xsl:template match='checkbox' name='checkbox' mode="grid">
  <xsl:param name='checkbox'/>
     <td><label><xsl:value-of select='@label'/></label></td>
     <td>
      <xsl:choose>
        <xsl:when test='@value="1"'>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           accesskey='R'
           onclick='Form.fnChanged()'
           checked='checked' />
        </xsl:when>
        <xsl:otherwise>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           onclick='Form.fnChanged()'
           accesskey='R' />
        </xsl:otherwise>
      </xsl:choose>
    </td>
  <tr><td height='10'></td></tr>
</xsl:template>

</xsl:stylesheet>
