<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="editorSpecSet"/>
</xsl:template>

<xsl:template match="editorSpecSet">
  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='../parameters/@features &lt; 4'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

<gjs:form
 title='Editor Integration Settings'
 jsFile='vcset73.js'
 onload='frmMain.editCheckOutValidation.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Settings for editor integration. Some settings apply to the Studio editor from InterSystems and to the Serenji editor from George James Software. Other settings only affect Serenji.
    <xsl:if test='$readonly=1'>
      NOTE: Callouts are not available on your edition of Deltanji.
    </xsl:if>
  </gjs:information>

<div id='divEditorSpecSet' class='visible' style='height: 200'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='200'/>
    <gjs:column width='220'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='editCheckOutValidation'
     accesskey='V'
     size='32'
     maxlength='2000'
     value='{@editCheckOutValidation}'
     onchange='Form.fnChanged()'
     readonly='{$readonly}'>
     <label>Check-out <u>v</u>alidation (function)</label>
     <hint>Enter a function</hint>
    </gjs:input>

    <xsl:apply-templates select="/Form/editorSpecSet/checkbox" mode='grid'>
                <xsl:with-param name='value'/>
		<xsl:with-param name='name'/>
		<xsl:with-param name='label'/>
		<xsl:with-param name='accesskey'/>
    </xsl:apply-templates>
 
  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

<xsl:template match='checkbox' name='checkbox' mode="grid">
  <xsl:param name='checkbox'/>
     <xsl:choose>
	<xsl:when test='@name="serenjiAllowedNamespaces"'>
      <tr><td height='16'></td></tr>
	   <tr>
     	    <td colspan='2'>
       	     <label><b>Serenji only</b></label>
     	    </td>
    </tr>
	</xsl:when>
     </xsl:choose>
     <tr>
     <td><label><xsl:value-of select='@label'/></label></td>
     <td>
      <xsl:choose>
        <xsl:when test='@value="1"'>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           accesskey='{@accesskey}'
           onclick='Form.fnChanged()'
           checked='checked' />
        </xsl:when>
        <xsl:otherwise>
          <input 
           type='checkbox'
           id='{@name}'
           name='{@name}'
           onclick='Form.fnChanged()'
           accesskey='{@accesskey}' />
        </xsl:otherwise>
      </xsl:choose>
     </td>
     </tr>
</xsl:template>

</xsl:stylesheet>
