<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- Stripped down main page, just containing the right-hand panel
To use, include this in your own xsl, e.g.

<xsl:import href='Main_Alone.xsl' />

<xsl:template name='headExtra'>
	<script src='MyClass.js' />
</xsl:template>

<xsl:template match='/main'>
	<xsl:call-template name='main'>
     <xsl:with-param name='gjsOnLoad'>MyClass.fnList()</xsl:with-param>
   </xsl:call-template>
</xsl:template>

-->

<xsl:template name="main">
  <xsl:param name="gjsOnLoad"/>
	<html>
		<xsl:call-template name="head"/>
		<xsl:call-template name="body">
      <xsl:with-param name="gjsOnLoad" select="$gjsOnLoad"/>
    </xsl:call-template>
	</html>
</xsl:template>
	

<!-- Generate main page head section -->
<xsl:template name="head">
	<head>
	
		<!-- Load jQuery -->
		<script src='jquery.min.js'></script>

    <!--  Load the Simple Combobox plugin -->
	  <script src='jquery.easing.min.js'></script>
	  <script src='jquery.scombobox.min.js'></script>
    <link rel='stylesheet' href='jquery.scombobox.min.css' type='text/css' />
	
		<!-- Load gJax utility package -->
		<link Rel='StyleSheet' Href='vc700.css' Type='text/css'/>
		<script src='vc700.js' />
		<script src='ServerLink.js' />
		<script src='gjsTree.js' />
		<script src='Main_Alone.js' />
		
		<!-- Load additional site/app-specific CSS -->
		<xsl:if test="@cssFile">
		  <link Rel='StyleSheet' Href='{@cssFile}' Type='text/css'/>
		</xsl:if>
		
		<xsl:call-template name="headExtra"/>
		
	</head>
</xsl:template>

<!-- Override this to add extra to head -->
<xsl:template name="headExtra"/>
	

<!-- Generate body of main page -->
<xsl:template name="body">
  <xsl:param name="gjsOnLoad"/>
	<!-- 

		onselectstart - disable text selection as this interferes with drag-n-drop
		                If you want text selection to be enabled for any specific element then
		                add onselectstart='window.event.cancelBubble=true;' and style='-moz-user-select: text;'
		                to the specific html element in question.
		ondragstart   - disable IE's built-in drag-n-drop to prevent icons being draggable by default
		                If you want it to be enabled for any specific element then
		                add ondragstart='window.event.cancelBubble=true;' to the specific
		                html element in question.
		scroll        - we don't want any scroll bars - the divs will have scroll bars

		Once loaded we can resize all the panels to fit the browser window.  By default they
		all start with a width and height of 0px.
	-->

	<body
	 onload='fnResize()'
	 onresize='fnResize()'
	 onmousemove='fnMouseMove()'
	 onmouseup='fnMouseUp()'
	 onselectstart='return false'
	 style='-moz-user-select: none;'
	 ondragstart='return false'
	 scroll='no'>
	<xsl:if test="$gjsOnLoad">
		<xsl:attribute name="gjsOnLoad">frameMain.<xsl:value-of select="$gjsOnLoad"/></xsl:attribute>
  </xsl:if>		
		
		<!-- Main division -->
		<div id='divOuter'>


			<!-- Main Panel -->
			<div id='divMain'>
					<!-- Main Panel Heading -->
					<div class='columnHeadingOuter' id='divMainHeadingOuter'>
						<div class='columnHeadingInner' id='divMainHeadingInner'>
							<div class='columnHeading' id='divMainHead' />
						</div>
					</div>
	
					<!-- Main Panel Body -->
					<div
					 id='divMainBody'
					 onscroll='fnScrollHeading("divMainBody","divMainHead")' /> <!-- scroll heading in sync with body -->

			</div>
		</div>
	</body>
</xsl:template>

 
</xsl:stylesheet>
