<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="printer"/>
</xsl:template>

<xsl:template match="printer">

<gjs:form
 title='Printers'
 jsFile='vcset21.js'
 onload='frmMain.printer.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='{/Form/@delete}'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    This form is used to define printers and other sequential output devices such as files.
  </gjs:information>

<div id='divPrinter' class='visible' style='height: 200'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='150'/>
    <gjs:column width='400'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='printer'
     accesskey='R'
     size='16'
     maxlength='16'
     value='{@printer}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>P<u>r</u>inter</label>
     <hint>Enter a name that identifies the printer/file device</hint>
    </gjs:input>

    <gjs:input
     id='outputDevice'
     accesskey='V'
     size='50'
     maxlength='200'
     value='{@outputDevice}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Output de<u>v</u>ice</label>
     <hint>The $I value of the device to be opened.  Use ??? as a wildcard.</hint>
    </gjs:input>

    <gjs:list1
     id='deviceType'
     accesskey='D'
     width='100'
     value='{@deviceType}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <label>Device <u>t</u>ype</label>
      <hint>Select the type of device</hint>
      <xsl:apply-templates select="/Form/devices/device" mode='list1' />
    </gjs:list1>

    <gjs:input
     id='openArguments'
     accesskey='A'
     size='50'
     maxlength='200'
     value='{@openArguments}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>Open <u>a</u>rguments</label>
     <hint>Arguments to the open command for this device</hint>
    </gjs:input>

    <gjs:input
     id='useArguments'
     accesskey='U'
     size='50'
     maxlength='200'
     value='{@useArguments}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label><u>U</u>se arguments</label>
     <hint>Arguments to the use command for this device</hint>
    </gjs:input>

    <gjs:input
     id='closeArguments'
     accesskey='L'
     size='50'
     maxlength='200'
     value='{@closeArguments}'
     onchange='Form.fnChanged()'
     readonly='0'>
     <label>C<u>l</u>ose arguments</label>
     <hint>Arguments to the close command for this device</hint>
    </gjs:input>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>
  <gjs:inputHidden id='oldPrinter' value='{@printer}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>


<!-- Device Type list box -->
<xsl:template match='device' mode="list1">
<item>
  <label><xsl:value-of select="@device" /></label>
  <value><xsl:value-of select="@device" /></value>
</item>
</xsl:template>


</xsl:stylesheet>
