<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="checkedOutObjectReport"/>
</xsl:template>

<xsl:template match="checkedOutObjectReport">
<gjs:form
 title='Checked-out Objects Report'
 jsFile='vc361.js'
 onload='frmMain.location.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='no'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>


  <gjs:information>
    The checked-out objects report is a spreadsheet with rows displaying details about each object which has its master version in the selected location(s).
    &nbsp;Objects are grouped by change request and the report may be limited to contain only those change requests overdue by a specified amount or more.
  </gjs:information>

  <div id='divCheckedOutObjectReport' class='visible' style='height: 270px;'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='140'/>
    <gjs:column width='400'/>
  </gjs:columnWidths>

  <gjs:fields>
    
     	<gjs:select
      	 id='location'
      	 accesskey='L'
      	 width='400'
      	 value='{@selectedLocation}'
	 size='10'>
	 <label><u>L</u>ocations</label>
         <xsl:apply-templates select='/Form/checkedOutObjectReport/locations/location' mode='list1' />
        </gjs:select>
    
     	<gjs:select
      	 id='locationClass'
      	 accesskey='C'
      	 width='400'
      	 value='{@selectedLocClass}'
	 size='5'>
	 <label>Location <u>C</u>lasses</label>
         <hint>The origin location for this route</hint>
         <xsl:apply-templates select='/Form/checkedOutObjectReport/locationClasses/locationClass' mode='list1' />
        </gjs:select>
     

    	<gjs:input
         id='numDaysOverdue'
         accesskey='N'
         size='5'
         maxlength='5'
         value='{@numDaysOverdue}'
         onchange='Form.fnChanged()'
         readonly='0'>
         <label><u>N</u>umber of days overdue</label>
        </gjs:input>


    </gjs:fields>

   </gjs:frame>
  </div>
 </gjs:form>
</xsl:template>

<!-- Location list boxes -->
<xsl:template match='location' mode="list1">
<item>
  <label><xsl:value-of select="@location" /> - <xsl:value-of select="@description" /></label>
  <value><xsl:value-of select="@location" /></value>
</item>
</xsl:template>


<!-- Location class list boxes -->
<xsl:template match='locationClass' mode="list1"> 
  <item>
     <label><xsl:value-of select="@locationClass" /></label>
     <value><xsl:value-of select="@locationClass" /></value>
  </item>
</xsl:template>

</xsl:stylesheet>
