<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>
<xsl:include href='Selector.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="versionByLocationReport"/>
</xsl:template>

<xsl:template match="/Form/versionByLocationReport">
<gjs:form
 title='Version By Location Matrix Report'
 jsFile='vc561.js'
 onload='frmMain.system.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='no'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>


  <gjs:information>
    The version by location matrix is a spreadsheet that has a row for each selected Object version and a column for each selected Location.
    &nbsp;If one or more Systems are selected then only Object versions that belong to these systems will be included in the matrix.
    &nbsp;A summary of selected Systems is included at the bottom of the spreadsheet.
  </gjs:information>

  <div id='divVersionByLocationReport' class='visible'>


      

<!-- Set up frame column widths -->
<gjs:frame>
	<gjs:columnWidths>
		<gjs:column width='160'/>
		<gjs:column width='400'/>
		<gjs:column width='20'/>
		<gjs:column width='20'/>
	</gjs:columnWidths>
	
	
	  <gjs:fields>
		    <tr>
					<td colspan='4'>
			
	     			<xsl:apply-templates select='/Form/versionByLocationReport/selectors' />
			
	   			</td>
		    </tr>
	  
		    <gjs:select
		   	 id='system'
		   	 accesskey='S'
		   	 width='400'
		   	 value='{@selectedSystem}'
				 size='4'>
					<label><u>S</u>ystems</label>
		      <xsl:apply-templates select='/Form/versionByLocationReport/systems/system' mode='list1' />
		    </gjs:select>


				<gjs:select
      	 id='location'
      	 accesskey='L'
      	 width='400'
      	 value='{@selectedLcode}'
				 size='4'>
				 <label><u>L</u>ocations</label>
         <hint>Select location(s) to include in the matrix</hint>
         <xsl:apply-templates select='/Form/versionByLocationReport/locations/location' mode='list1' />
				</gjs:select>

	
				<gjs:select
      	 id='locationClass'
      	 accesskey='N'
      	 width='400'
      	 value='{@selectedLclass}'
				 size='4'>
				 <label>Locatio<u>n</u> Lists</label>
         <hint>Select location list(s) to include in the matrix</hint>
         <xsl:apply-templates select='/Form/versionByLocationReport/locationClasses/locationClass' mode='list1' />
        </gjs:select>

	
   <tr><td colspan='4' height='5'></td></tr>
   <tr>
     <td colspan='4'>
        <table class='formLayoutTable'>
              <tr>
		<gjs:column width='150'/>
		<gjs:column width='50'/>
                <gjs:column width='70'/>
		<gjs:column width='50'/>
		<gjs:column width='70'/>
		<gjs:column width='50'/>
		<gjs:column width='70'/>
   </tr>           
      
   <tr>
     <td>
      <label>
	     <span class="caption">Show objects with status of </span>
      </label>
     </td>

     <td>  
      <label for="statMaster" accesskey='M'>
	     <span class="caption"><u>M</u>aster</span>
      </label>
     </td>
     <td>
        <input 
           type='checkbox'
           id='statMaster'
           name='statMaster'
           accesskey='M'
	         class="input"
	         onChange="Form.fnChanged()">
           <xsl:if test='@statMaster="M"'>
	          <xsl:attribute name="checked">checked</xsl:attribute>
	         </xsl:if>
	      </input>
     </td>

     <td>
      <label for="statActive" accesskey='A'>
	     <span class="caption"><u>A</u>ctive</span>
      </label>
     </td>
     <td>
        <input 
           type='checkbox'
           id='statActive'
           name='statActive'
           accesskey='A'
	         class="input"
	         onChange="Form.fnChanged()">
           <xsl:if test='@statActive="A"'>
	          <xsl:attribute name="checked">checked</xsl:attribute>
	         </xsl:if>
	      </input>
      </td>

      <td>
       <label for="statError" accesskey='E'>
	      <span class="caption"><u>E</u>rror</span>
       </label>
      </td>
      <td>
        <input 
           type='checkbox'
           id='statError'
           name='statError'
           accesskey='E'
	         class="input"
	         onChange="Form.fnChanged()">
           <xsl:if test='@statError="E"'>
	          <xsl:attribute name="checked">checked</xsl:attribute>
	         </xsl:if>
	      </input>
      </td>

     </tr>
   </table>
  </td>
 </tr>


    </gjs:fields>

   </gjs:frame>
  </div>
 </gjs:form>
</xsl:template>



<!-- Location list boxes -->
<xsl:template match='system' mode="list1">
<item>
  <label><xsl:value-of select="@system" /> - <xsl:value-of select="@description" /></label>
  <value><xsl:value-of select="@system" /></value>
</item>
</xsl:template>


<!-- Location list boxes -->
<xsl:template match='location' mode="list1">
<item>
  <label><xsl:value-of select="@location" /> - <xsl:value-of select="@description" /></label>
  <value><xsl:value-of select="@location" /></value>
</item>
</xsl:template>


<!-- Location class list boxes -->
<xsl:template match='locationClass' mode="list1">
<item>
  <label><xsl:value-of select="@locationClass" /></label>
  <value><xsl:value-of select="@locationClass" /></value>
</item>
</xsl:template>


<!-- Object selector -->
<xsl:template match='selectors'>
	<xsl:call-template name='gjs:selector' />
</xsl:template>


</xsl:stylesheet>
