<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">


<!-- Import the standard change request select form, then override and extend as required -->
<xsl:import href='ChangeRequestSelect.xsl'/>


<!-- Add custom search fields.
     For greater layout control, implement customFieldTable template (not illustrated here)
-->
<xsl:template name='customFields'>

      <tr>
        <gjs:input
         id='customDepartment'
         accesskey='P'
         size='30'
         maxlength='2000'
         value='{Custom/@department}'
         onfocus='fnSelectRow(null)'
         onchange='fnChangeSelection()'
         readonly='0'>
         <label>De<u>p</u>artment</label>
         <hint>The department which owns the change</hint>
        </gjs:input>
        <td></td>
      </tr>

      <tr>
        <gjs:list1
         id='customPriority'
         accesskey='P'
         width='100'
         value='{Custom/@priority}'
         onfocus='fnSelectRow(null)'
         onchange='fnChangeSelection()'
         readonly='0'>
          <label><u>P</u>riority</label>
          <hint>The priority applicable to the change</hint>
          <item>
            <label></label>
            <value></value>
          </item>
          <xsl:apply-templates select="Custom/priorities/priority" mode='listItem'/>
        </gjs:list1>
        <td></td>
      </tr>

</xsl:template>


<!-- Generate option list of priorities -->
<xsl:template match='Custom/priorities' mode='listItem'>
  <item>
    <label></label>
    <value></value>
  </item>
  <xsl:apply-templates select='priority' mode='listItem'/>
</xsl:template>


<xsl:template match='priority' mode="listItem">
  <item>
    <label><xsl:value-of select="@description" /></label>
    <value><xsl:value-of select="@code" /></value>
  </item>
</xsl:template>


<!-- Add any supporting client side javascript code here -->
<xsl:template name='customJavaScript'>
  <script>
    <![CDATA[
  
      Custom = {}

        // Collect all form data into a single string delimited by $c(2)
      Custom.fnArguments = function() {
        //
      	var delimiter = '\002'
      	var arguments
      	//
      	arguments  = frmMain.customDepartment.value
      	arguments += delimiter + frmMain.customPriority.value
      	//
      	return arguments
      }

        // Clear custom fields
      Custom.fnClear = function() {
      	//
      	frmMain.customDepartment.value = '';
      	frmMain.customPriority.value = '';
      }

    ]]>
  </script>
</xsl:template>


</xsl:stylesheet>
