<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="transferSet"/>
</xsl:template>

<xsl:template match="transferSet">
  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='../@method="view"'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

<gjs:form
 title='Transfer Settings'
 jsFile='vcset78.js'
 onload='frmMain.INIT.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Site-specific code can be called at various points during a transfer. The code should be placed in a
    routine accessible from all Deltanji-managed areas. A name beginning '%vcmz' is recommended. Some callouts
    should be parameterless labels, others expect one or more parameters. Consult the hint on each field,
    or the Deltanji documentation.
    <xsl:if test='$readonly=1'>
      NOTE: Callouts are not available on your edition of Deltanji.
    </xsl:if>
  </gjs:information>

<div id='divtransferSet' class='visible' style='height: 200'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='180'/>
    <gjs:column width='260'/>
  </gjs:columnWidths>

  <gjs:fields>

    <tr>
     <td colspan='2'>
      <label><b>Transfer Callouts</b></label>
     </td>
    </tr>

    <gjs:input
     id='PREINIT'
     size='30'
     maxlength='2000'
     value='{@PREINIT}'
     onchange='Form.fnChanged()'
     accesskey='P'
     readonly='{$readonly}'>
     <label>Transfer <u>p</u>re-initialization callout</label>
     <hint>Enter 'label^%routine', where label accepts one argument, i.e. label(dataref)</hint>
    </gjs:input>

    <gjs:input
     id='INIT'
     size='30'
     maxlength='2000'
     value='{@INIT}'
     onchange='Form.fnChanged()'
     accesskey='I'
     readonly='{$readonly}'>
     <label>Transfer <u>i</u>nitialization callout</label>
     <hint>Enter 'label^%routine', where label accepts no arguments</hint>
    </gjs:input>

    <gjs:input
     id='TERM'
     size='30'
     maxlength='2000'
     value='{@TERM}'
     onchange='Form.fnChanged()'
     accesskey='T'
     readonly='{$readonly}'>
     <label><u>T</u>ransfer termination callout</label>
     <hint>Enter 'label^%routine', where label accepts no arguments</hint>
    </gjs:input>

    <gjs:input
     id='POSTTERM'
     size='30'
     maxlength='2000'
     value='{@POSTTERM}'
     onchange='Form.fnChanged()'
     accesskey='S'
     readonly='{$readonly}'>
     <label>Transfer po<u>s</u>t-termination callout</label>
     <hint>Enter 'label^%routine', where label accepts one argument, i.e. label(dataref)</hint>
    </gjs:input>

    <gjs:input
     id='PROG'
     size='30'
     maxlength='2000'
     value='{@PROG}'
     onchange='Form.fnChanged()'
     accesskey='B'
     readonly='{$readonly}'>
     <label><u>B</u>efore object transfer callout</label>
     <hint>Enter 'label^%routine', where label accepts no arguments</hint>
    </gjs:input>

    <gjs:input
     id='XFER'
     size='30'
     maxlength='2000'
     value='{@XFER}'
     onchange='Form.fnChanged()'
     accesskey='A'
     readonly='{$readonly}'>
     <label><u>A</u>fter object transfer callout</label>
     <hint>Enter 'label^%routine', where label accepts no arguments</hint>
    </gjs:input>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>

</xsl:stylesheet>
