<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<!-- Note that this is a generic gJax component, not a VC/m-specific one. Text should not refer to VC/m -->
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
 <xsl:choose>
   <xsl:when test='/Form/user/@user=""'>
     <xsl:apply-templates select="user" mode="nouser"/>
   </xsl:when>
   <xsl:when test='/Form/parameters/@disallowPassword="1"'>
     <xsl:apply-templates select="user" mode="nochange"/>
   </xsl:when>
   <xsl:otherwise>
     <xsl:apply-templates select="user" mode="change"/>
   </xsl:otherwise>
 </xsl:choose>
</xsl:template>


<xsl:template match="user" mode="nouser">

<gjs:form
 title='Change Password'
 save='no'
 close='enabled'
 delete='no'
 print='no'
 help='no'
 ok='no'
 cancel='no'>

  <gjs:information>
    You are not logged in, so cannot change your password.
  </gjs:information>
</gjs:form>
</xsl:template>


<xsl:template match="user" mode="nochange">

<gjs:form
 title='Change Password'
 save='no'
 close='enabled'
 delete='no'
 print='no'
 help='no'
 ok='no'
 cancel='no'>

  <gjs:information>
    Your password is managed externally and so cannot be changed here.
    Consult your system manager for advice.
  </gjs:information>
</gjs:form>
</xsl:template>


<xsl:template match="user" mode="change">

<gjs:form
 title='Change Password'
 jsFile='User_ChangePassword_Form.js'
 onload='frmMain.currentPassword.focus();'
 save='no'
 close='no'
 delete='no'
 print='no'
 help='no'
 ok='{/Form/@ok}'
 cancel='enabled'>

  <gjs:information>
    To change your password, please enter your current password and then your new password twice.
  </gjs:information>

<div id='divUser' class='visible' style='height: 140'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='170'/>
    <gjs:column width='290'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:input
     id='user'
     size='30'
     maxlength='30'
     value='{@user}'
     readonly='1'>
     <label>User ID</label>
     <hint>The username you are currently logged in under</hint>
    </gjs:input>

  <tr title='Enter your current password.'>
    <gjs:caption for='currentPassword' accesskey='U'>
      <label>C<u>u</u>rrent password</label>
    </gjs:caption>
    <td>
      <input 
       type='password' 
       size='30'
       maxlength='30' 
       id='currentPassword' 
       name='currentPassword' 
       value='' 
       class='input'
       onChange='Form.fnChanged()'/>
    </td>
  </tr>

  <tr title='Enter your new password.'>
    <gjs:caption for='password1' accesskey='N'>
      <label><u>N</u>ew password</label>
    </gjs:caption>
    <td>
      <input 
       type='password' 
       size='30'
       maxlength='30' 
       id='password1' 
       name='password1' 
       value='' 
       class='input'
       onChange='Form.fnChanged()'/>
    </td>
  </tr>

  <tr title='Re-enter the new password to confirm that it has been typed correctly'>
    <gjs:caption for='password2' accesskey='R'>
      <label><u>R</u>epeat new password</label>
    </gjs:caption>
    <td>
      <input 
       type='password' 
       size='30'
       maxlength='30' 
       id='password2' 
       name='password2' 
       value='' 
       class='input' 
       onChange='Form.fnChanged()'/>
    </td>
  </tr>

  </gjs:fields>

  </gjs:frame>
</div>

</gjs:form>
</xsl:template>

</xsl:stylesheet>
