//vc/ gJax Tree Control
//vc/ Copyright 2003,2006 George James
//vc/ Object:    gjsTree.js
//vc/ Component: T.gjsTree.js


gjsTree = {}

// Global variables are used to hold the sort arguments because they cannot be passed directly to the
// fnCompare method.
//var gjsTree.iColumn;
//var gjsTree.bDirection;

// The currently selected item in the tree
gjsTree.oSelectedItem=null
gjsTree.resizingHeading=false


	// Initialise tree control - IS THIS EVER INVOKED?
gjsTree.init = function() {
	//
	// Run the gjsLoad code on the tree control which sets-up the column widths	
	eval(getAttr("#divMainBody","gjsLoad"))
	//
	// Add an onscroll event handler to the body of the tree control
	$("#divMainBody").on("scroll",gjsTree.fnMainBodyOnScroll)
}


	// OnScroll event handler for divMainBody
gjsTree.fnMainBodyOnScroll = function() {
	gjsTree.fnScrollHeading("divMainBody","divMainHead")
}


	// Keyboard event handler for tree control row
gjsTree.fnToggleKey = function(clickId, event) {
	//
	var thisCell=document.getElementById(clickId)
	var bOK=false
	//
	if (getAttr(thisCell,"gjsState")=='closed') {
		// <CursorRight>
		if (event.which==39) bOK=true
		// + on numpad
		if (event.which==107) bOK=true
		// + on main
		if (event.which==187) bOK=true
	}
	//
	if (getAttr(thisCell,"gjsState")=='open') {
		// <CursorLeft>
		if (event.which==37) bOK=true
		// - on numpad
		if (event.which==109) bOK=true
		// - on main
		if (event.which==189) bOK=true
	}
	//
	if (bOK) {
		gjsTree.fnToggle(thisCell)
    gjsTree.fnEventStop(event)
	}
}


	// Private - Open/Close a folder (fired by clicking on its +/- button)
gjsTree.fnToggle = function(thisCell) {
  //
  var oPlus,oHiddenRow,oText,sNameProp
  //
  oPlus=document.getElementById(getAttr(thisCell,"gjsPlusId"))
  oHiddenRow=document.getElementById(getAttr(thisCell,"gjsHiddenRowId"))
  oText=document.getElementById(getAttr(thisCell,"gjsTextId"))
  sNameProp=gjsTree.fnGetNameProp(getAttr(oPlus,"src"))
  //
  if (getAttr(thisCell,"gjsState")=="closed") {
    if (sNameProp=="vcm_plus_tbr.gif") setAttr(oPlus,"src","vcm_working_tbr.gif")
    if (sNameProp=="vcm_plus_tr.gif") setAttr(oPlus,"src","vcm_working_tr.gif")
    setAttr(thisCell,"gjsState","open")
    //
    gCurrentCell=thisCell
    if (getAttr(thisCell,"gjsServerLink")=="no") eval(getAttr(thisCell,"gjsRowGenerator"))
    else parent.serverLink.fnDo('gjsTree.fnToggleResult',getAttr(thisCell,"gjsRowGenerator"),eval(getAttr(thisCell,"gjsArguments")))
  } else {
    if (sNameProp=="vcm_minus_tbr.gif") setAttr(oPlus,"src","vcm_plus_tbr.gif")
    if (sNameProp=="vcm_minus_tr.gif") setAttr(oPlus,"src","vcm_plus_tr.gif")
    if (sNameProp=="vcm_working_tbr.gif") setAttr(oPlus,"src","vcm_plus_tbr.gif")
    if (sNameProp=="vcm_working_tr.gif") setAttr(oPlus,"src","vcm_plus_tr.gif")
    setAttr(thisCell,"gjsState","closed")
    $(oHiddenRow).removeClass().addClass('tocItemHide')
    //
    // Synchronise column headings to match the now-collapsed item
    Main.fnSetMainHead(getAttr(fnElement(getAttr(thisCell,"gjsRowId")+"body").parentNode,"gjsReferenceHeadingId"))
  }
}


gjsTree.fnToggleResult = function(result) {
  //
	var oHiddenRow,oTargetCell,oPlus,sNameProp,oDivMainBody
	//
	oHiddenRow=document.getElementById(getAttr(gCurrentCell,"gjsHiddenRowId"))
	oTargetCell=document.getElementById(getAttr(gCurrentCell,"gjsTargetCellId"))
	oPlus=document.getElementById(getAttr(gCurrentCell,"gjsPlusId"))
  sNameProp=gjsTree.fnGetNameProp(getAttr(oPlus,"src"))
	//
	// If ServerLink.xsl is used then result will be an object reference
	if (typeof(result)=='object') {
		oDivMainBody=result.getElementById('divMainBody')
		if (oDivMainBody) {
			//
			// Copy any folder caption heading
			ServerLink.fnUpdate(result,'divFolderHeadingCaption')
			//
			// Copy divMainBody from result to document
			oTargetCell.innerHTML=oDivMainBody.innerHTML
			//
			// Copy any column headings to the correct place
			ServerLink.fnUpdate(result,'divMainHead', Main.fnIdOfHeadingDiv(oTargetCell))
			//
			if (getAttr(oDivMainBody,"gjsLoad")) eval(getAttr(oDivMainBody,"gjsLoad"))
			//
			// Reveal the hidden row
			$(oHiddenRow).removeClass().addClass("tocItemShow")
		}
	}
	else {
		if (result!='') {
			oTargetCell.innerHTML=result
			$(oHiddenRow).removeClass().addClass("tocItemShow")
		}
    //
    // If no results returned then replace the +/- icon with a regular T or L icon
		else {
      if (sNameProp=="vcm_working_tbr.gif") setAttr(oPlus,"src","vcm_t.gif")
      if (sNameProp=="vcm_minus_tbr.gif") setAttr(oPlus,"src","vcm_t.gif")
      if (sNameProp=="vcm_working_tr.gif") setAttr(oPlus,"src","vcm_l.gif")
      if (sNameProp=="vcm_minus_tr.gif") setAttr(oPlus,"src","vcm_l.gif")
      sNameProp=""
		}
	}
  if (sNameProp=="vcm_working_tbr.gif") setAttr(oPlus,"src","vcm_minus_tbr.gif")
  if (sNameProp=="vcm_working_tr.gif") setAttr(oPlus,"src","vcm_minus_tr.gif")
}


  // Get filename from a URL
  // TODO: Should strip-off ?search and #anchor if present
gjsTree.fnGetNameProp = function(sSrc) {
  return sSrc.substr(sSrc.lastIndexOf("/")+1)
}



	// Public - Select Item (get focus)
gjsTree.fnItemSelect = function(oCell) {
	//
	// Deselect any previously selected item (may need to add multi-select support)
	if (gjsTree.oSelectedItem) {
		$(gjsTree.oSelectedItem).removeClass().addClass(getAttr(gjsTree.oSelectedItem,'gjsSavedClassName'))
		gjsTree.oSelectedItem=null
	}
	//
	gjsTree.oSelectedItem=oCell
	//
	// Highlight the selected cell
	setAttr(gjsTree.oSelectedItem,'gjsSavedClassName',gjsTree.oSelectedItem.className)
	$(gjsTree.oSelectedItem).removeClass().addClass('selected')
	//
	// Give the item focus (so that it has a dotted line around it)
	gjsTree.oSelectedItem.focus()
	//
}


	// When mouse down on a column resize element store the context for further processing
gjsTree.fnResizeMouseDown = function(event,oResizeHandle,resultTableId,referenceHeadingId) {
	//
	// Remember start position of cursor in the horizontal plane
	gjsTree.g_resizeStartX=event.clientX
	//
	// Remember the original width of the column that we are about to resize (the previous column to this one)
	gjsTree.g_resizeStartWidth=$(oResizeHandle).parent().parent().prev().width()
	gjsTree.g_resultTableId=resultTableId
	gjsTree.g_referenceHeadingId=referenceHeadingId
	g_oResize=oResizeHandle
	gjsTree.resizingHeading=true
	$("html").addClass("dragging-col");
	gjsTree.fnEventStop(event);
}


	// End of resize activity (persist on server)
gjsTree.fnResizeMouseUp = function(event,oResizeHandle) {
	//
	var delimiter='\001'
	var oCell,treeId,columnId,offset,iWidth
	//
	offset=event.clientX-gjsTree.g_resizeStartX
	iWidth=gjsTree.g_resizeStartWidth+offset
	if (iWidth<1) iWidth=1
	//
	oCell=$(oResizeHandle).parent().parent()
	treeId=getAttr($(oCell).parent().parent().parent(),"gjsTreeId")	
	columnId=getAttr($(oCell).prev(),"gjsColumnId")
	//
	// Persist on server
	if ((typeof(treeId)!="undefined") && (typeof(columnId)!="undefined") && (columnId!="")) {
		ServerLink.fnDo('gjsTree.fnResizeMouseUpResult','Tree.fnSetColumnWidth',treeId+delimiter+columnId+delimiter+iWidth)
	}
	//
}

	// Do nothing with result ***? Is this necessary?
gjsTree.fnResizeMouseUpResult = function(result)	{}


	// Set the width of a column (called from Main.fnResizeMouseMove() event handler)
gjsTree.fnColumnWidthSet = function(event) {
  //
  var delimiter='\001'
	var offset,iWidth,iColumn,oResultTable,oCell
	//
	// Return if there is no resize in progress
  if (typeof(g_oResize)=="undefined") return
  if (!g_oResize) return
	//
	// If the left mouse button is no longer pressed then fire the mouse up event and return
	// Accidental behaviour - if the mouse up event happens off of the column heading then it is not
	// persisted on the server, this provides a way for the user to do temporary resizing.
	/*
	if (event.button==0) {
		g_oResize=null
		return	
	}
	*/
	//
	// Locate the target cell
	oCell=$(g_oResize).parent().parent().prev()
	//
	offset=event.clientX-gjsTree.g_resizeStartX
	iWidth=gjsTree.g_resizeStartWidth+offset
	if (iWidth<1) iWidth=1
	iColumn=gjsTree.fnColumn(oCell)
	//
	// Resize the corresponding column in the currently displayed column heading table
	oCell.width=iWidth
	$(oCell).css("min-width",iWidth+"px")
	$(oCell).css("max-width",iWidth+"px")
	$(oCell).css("width",iWidth+"px")
	//
	// Unless the result table is empty (footer doesn't count), resize the corresponding column in the associated data table (if it exists)
	oResultTable=document.getElementById(gjsTree.g_resultTableId)
	if ((oResultTable.rows.length>0) && (oResultTable.rows[0].parentElement.tagName!='TFOOT') && (oResultTable.rows[0].cells.length>iColumn)) {
		$.each(oResultTable.rows,function(key,row) {
			$(row.cells[iColumn]).css("min-width",iWidth+"px")
			$(row.cells[iColumn]).css("max-width",iWidth+"px")
			$(row.cells[iColumn]).css("width",iWidth+"px")
		});
	}
	//
	// Resize the corresponding column in the hidden reference column heading table
	oDivReferenceHeading=document.getElementById(gjsTree.g_referenceHeadingId)
	$(oDivReferenceHeading.children[0].rows[0].cells[iColumn]).css("min-width",iWidth+"px")
	$(oDivReferenceHeading.children[0].rows[0].cells[iColumn]).css("max-width",iWidth+"px")
	$(oDivReferenceHeading.children[0].rows[0].cells[iColumn]).css("width",iWidth+"px")
	//
}


	// Iterate through all columns in the column heading and set the column width to that of the column heading.
	// The column headings will have been sized by the definitional gjs:treeColumnHeading.width property or by user override. 
	// This method is fired by the gjsLoad event handler for divMainBody.
gjsTree.fnResizeColumns = function(resultTableId,referenceColumnHeadingId) {
	//
	var oResultTable,oReferenceColumnHeading,oCells,iColumn,iWidth
	//
	oResultTable=document.getElementById(resultTableId)
	//
	// Unless the result table is empty (footer doesn't count), adjust the width of the columns in the first row (the other rows will follow suit)
	if ((oResultTable.rows.length>0) && (oResultTable.rows[0].parentElement.tagName!='TFOOT')) {
		//
		oReferenceColumnHeading=document.getElementById(referenceColumnHeadingId)
		oCells=oReferenceColumnHeading.children[0].rows[0].cells
		//
		for (iColumn=0; iColumn<oCells.length; iColumn++) {
			// Resize the corresponding column in the associated data table (if it exists)
			iWidth=oCells[iColumn].width
			$.each(oResultTable.rows,function(index,row) {
				if ((iWidth!="") && (row.cells.length>iColumn)) {
					row.cells[iColumn].width=iWidth
					$(row.cells[iColumn]).css({
						"min-width":iWidth+"px",
						"width":iWidth+"px"
					});
					if (!$(row.cells[iColumn]).hasClass("subrow")) {
						$(row.cells[iColumn]).css({
							"max-width":iWidth+"px"
						});
					}
				}
			});
		}
	}
}


	// Sort <tbody> row-groups within a table
	// Usage:
	//   onclick='gjsTree.fnSort(oSortButton,oTable,iColumnOffset,divReferenceHeadingId,divMainHeadId)'
	// Inputs:
	//   oSortButton   - The object (normally a table cell) that is clicked on to sort a column
	//   oTable        - A reference to a table body or table object
	//   iColumnOffset - The level within the tree that we are sorting at
	//   divReferenceHeadingId  - id of the hidden reference div containing the heading for this section of the tree
	//   divMainHeadId   - id of the place where the column headings are displayed
	// Outputs:
	//   None
	//
gjsTree.fnSort = function(oSortButton,oTable,iColumnOffset,divReferenceHeadingId,divMainHeadId) {
	//
	var oCell,oHeadingTable,oDivReferenceHeading
	var bDirection,iCurrentColumn,iNewColumn
	var i,sSrc,bodies
  //
	var arrImages = new Array()
	var arrBodies = new Array()
	//
  // Get the column number of the cell that was clicked
  oCell=gjsTree.fnGetParentOfType(oSortButton,"TD")
  iNewColumn=gjsTree.fnColumn(oCell)
  //
  // Get a reference to the reference copy of the column headings
  oDivReferenceHeading=document.getElementById(divReferenceHeadingId)
  //
  // Get a reference to the div containing the reference copy of the column headings
  // Assume that the first element in the div is the table (hopefully there shouldn't be anything else)
  oHeadingTable=$(oDivReferenceHeading).children('table:first-of-type').get();
  //
  // Walk all the images in the heading table
  //   - determine which is the current sort column by looking at the icon that is displayed
  //   - determine which direction the sort is currently
  //   - reset the icon back to normal
  //
  bDirection=true
  iCurrentColumn=0
  //
  arrImages=oDivReferenceHeading.getElementsByTagName("img")
  //
  for (i=0; i<arrImages.length; i++) {
    //
    sSrc=getAttr(arrImages[i],"src")
    //
    if (gjsTree.fnGetNameProp(sSrc)=="gjsSortAscending.gif") {
      bDirection=true
      oCell=gjsTree.fnGetParentOfType(arrImages[i],"TD")
      iCurrentColumn=gjsTree.fnColumn(oCell)
      setAttr(arrImages[i],"src","gjsSortNormal.gif")
      break
    }
    if (gjsTree.fnGetNameProp(sSrc)=="gjsSortDescending.gif") {
      bDirection=false
      oCell=gjsTree.fnGetParentOfType(arrImages[i],"TD")
      iCurrentColumn=gjsTree.fnColumn(oCell)
      setAttr(arrImages[i],"src","gjsSortNormal.gif")
      break
    }
  }
  //
  // If the current column has been clicked then toggle the sort direction...
  if (iNewColumn==iCurrentColumn) {
    if (bDirection==true) bDirection=false
    else bDirection=true
  }
  // ...otherwise sort in ascending order (true)
  else bDirection=true
  //
	// Set the sort icon for the selected column
	if (bDirection) gjsTree.fnSetIcon($(oHeadingTable).find('tr').first().find('td').eq(iNewColumn)[0],"gjsSortAscending.gif")
	else gjsTree.fnSetIcon($(oHeadingTable).find('tr').first().find('td').eq(iNewColumn)[0],"gjsSortDescending.gif")
	//
  // Copy the reference copy of the column headings to the display div
  document.getElementById(divMainHeadId).innerHTML=oDivReferenceHeading.innerHTML
  //
	// Move the contents of each table body to a javascript array
	bodies=oTable.tBodies.length
	for (i=0; i<bodies; i++) arrBodies[i]=oTable.removeChild(oTable.tBodies[0])
	//
  // Private variables cannot be passed to the sort method, so we have to use
  // global variables.  Set them here:
  gjsTree.iColumn=iNewColumn
  gjsTree.bDirection=bDirection
  //
	// Sort the bodies using the built-in javascript sort method
	arrBodies.sort(gjsTree.fnCompare)
	//
	// Move the contents of the sorted array back into the table
	for (i=0; i<bodies; i++) oTable.appendChild(arrBodies[i])
  //
  // Reset the continuation lines
  gjsTree.fnResetMores(oTable,iColumnOffset)
  //
	// If there is at least one row displayed (footer doesn't count), set the column widths for the first row in the table by copying them from the reference heading table
	// allowing for heading table having more columns (e.g. empty end one to permit predecessor to be resized)
	// and avoiding setting a width on the final cell of the row because this is the width="*" expansion cell
	if ((oTable.rows.length>0) && (oTable.rows[0].parentElement.tagName!='TFOOT')) {
		oReferenceHeading=document.getElementById(getAttr(oTable,"gjsReferenceHeadingId"))
		for (i=0; i<oReferenceHeading.children[0].rows[0].cells.length ;i++) {
			if ((oTable.rows[0].cells.length-1)>i) $(oTable.rows[0].cells[i]).width($(oReferenceHeading.children[0].rows[0].cells[i]).width())
		}
	}
}


	// Compare two tbody objects
	// If any cell has a gjsSort property then use that to sort on, otherwise use the
	// cell's innerText.
	//
gjsTree.fnCompare = function(oBody1,oBody2) {
	//
	var string1,string2
	var number1,number2
	var bIsString1,bIsString2
	var iColumn=gjsTree.iColumn
	var bDirection=gjsTree.bDirection
	//
  string1=''
  if ($(oBody1).children().length>0 && $(oBody1).children().first().children().eq(iColumn)[0]) {
  	if (getAttr($(oBody1).children().first().children().eq(iColumn)[0],"gjsSort")) string1=getAttr($(oBody1).children().first().children().eq(iColumn)[0],"gjsSort");
	  else string1=$(oBody1).children().first().children().eq(iColumn).text().toUpperCase();
	}
	//
  string2=''
  if ($(oBody2).children().length>0 && $(oBody2).children().first().children().eq(iColumn)[0]) {
  	if (getAttr($(oBody2).children().first().children().eq(iColumn)[0],"gjsSort")) string2=getAttr($(oBody2).children().first().children().eq(iColumn)[0],"gjsSort");
	  else string2=$(oBody2).children().first().children().eq(iColumn).text().toUpperCase();
	}
	//
  // Get the types of string1 and string2
  number1=parseFloat(string1)
  number2=parseFloat(string2)
	bIsString1=isNaN(number1)
	bIsString2=isNaN(number2)
	//
  // There are four cases:
  // Case 1: Both strings are strings
  //         Perform string comparisons
  if (bIsString1 && bIsString2) {
  	if (bDirection) {
  		if (string1>string2) return 1;
  		if (string1==string2) return 0;
  		if (string1<string2) return -1;
  	}
  	else {
  		if (string1>string2) return -1;
  		if (string1==string2) return 0;
  		if (string1<string2) return 1;
  	}
  }
  //
  // Case 2: string1 is a string, string2 is a number
  //         string2 (the number) sorts before string1
  if (bIsString1 && !bIsString2) {
  	if (bDirection) return 1
    else return -1
  }
  //
  // Case 3: string2 is a string, string1 is a number
  //         string2 (the string) sorts after string1
  if (!bIsString1 && bIsString2) {
    if (bDirection) return -1
    else return 1
  }
  // Case 4: Both strings are numbers
  //         Perform numeric comparisons
  if (!bIsString1 && !bIsString2) {
  	if (bDirection) {
  		if (number1>number2) return 1;
  		if (number1==number2) return 0;
  		if (number1<number2) return -1;
  	}
  	else {
  		if (number1>number2) return -1;
  		if (number1==number2) return 0;
  		if (number1<number2) return 1;
  	}    
  }
}


gjsTree.fnSetIcon = function(oSortButton,sIcon) {
	//
	// Loop through the child nodes of the sortButton object.  If any node is an element of class sortIcon
	// set its src attribute to the appropriate image.
	for (var i=0; i<oSortButton.childNodes.length;i++) {
		if ($(oSortButton.childNodes[i]).hasClass('sortIcon')) setAttr(oSortButton.childNodes[i],"src",sIcon)
		gjsTree.fnSetIcon(oSortButton.childNodes[i],sIcon) // walk all child nodes recursively
	}
}


  // Calculate the column number of a cell by counting the number of previous siblings
gjsTree.fnColumn = function(oCell) {
  var iColumn
  iColumn=0
  while (oCell) {
    oCell=$(oCell).prev()[0]
    iColumn += 1
  }
  return iColumn-1
}


  // Walk parent containers until we get to an element of the required type
  // Return a reference to that element
gjsTree.fnGetParentOfType = function(oElement,sType) {
  while (oElement.nodeName!=sType) oElement=oElement.parentNode
  return oElement
}


  // After a tree has been sorted this method is used to reset the continuation cells for the
  // level that has been sorted.
  // It iterates through all the bodies in the table that has been sorted, and for each body, if the
  // sub-folder is open, will iterate through the bodies of that sub-table as well (recursively).
  // The cell column number that needs adjustment is the same in all sub-tables.
  //
  // All cells will have a regular continuation cell, except the last whcih will have an L shaped one.
  //
  // If a table has a footer (max number of items message) then the last body is treated as normal and
  // the footer is given the L shaped treatment.
gjsTree.fnResetMores = function(oTable,iLevel) {
  //
  var iBodies,i,sMore
  //
  // For each table body, rewrite the more cell
	iBodies=oTable.tBodies.length
	for (i=0; i<iBodies; i++) {
	  sMore="T"
	  if (i==(iBodies-1) && !oTable.tFoot) sMore="L"
    gjsTree.fnWriteCells(oTable.tBodies[i],iLevel,sMore)		
	}
	//
	// Finally, reset header and footer
  if (oTable.tHead) gjsTree.fnWriteCells(oTable.tHead,iLevel,"T")		
  if (oTable.tFoot) gjsTree.fnWriteCells(oTable.tFoot,iLevel,"L")		
}


  // Write the appropriate image into the appropriate cell of the first row if the table body.
  // If the second row is an open sub-folder then iterate through all it's bodies and call this
  // function recursively.
  //
gjsTree.fnWriteCells = function(oBody,iLevel,sMore) {
  //
  var i,oSubTable,iBodies
  //
  // Make sure that the body has some rows
  if (oBody.rows.length==0) return
  //
  // Write the appropriate image
  gjsTree.fnSetImage(oBody.rows[0].cells[iLevel].childNodes[0],sMore)
  //
  // If this row is the last one in the table, then all continuation cells after this will be blank
  if (sMore=="L") sMore=" "
  //
  // If this body contains a second row and it is displayed, then iterate through any tables
  // inside the first cell of the row and reset their continuation cells
  if ((oBody.rows.length==2) && ($(oBody.rows[1]).hasClass('tocItemShow'))) {
    //
    oSubTable=oBody.rows[1].cells[0].childNodes[0]
    //
    while (oSubTable) {
      if (oSubTable.nodeName=="TABLE") {
        //
        //oSubTable=oBody.rows[1].cells[0].childNodes[1]
  	    iBodies=oSubTable.tBodies.length
        //
        // walk all bodies of the sub-table
  	    for (i=0; i<iBodies; i++) {
          gjsTree.fnWriteCells(oSubTable.tBodies[i],iLevel,sMore)
  	    }
        //
        // Now process header and footer
        if (oSubTable.tHead) {
          gjsTree.fnWriteCells(oSubTable.tHead,iLevel,sMore)
  	    }
        if (oSubTable.tFoot) {
          gjsTree.fnWriteCells(oSubTable.tFoot,iLevel,sMore)
  	    }
      }
      //
  	  // get next element in cell
  	  oSubTable=oSubTable.nextElementSibling
    }
  }
}


  // Adjust the image in a continuation cell, based on the type of image that was there
  // before and on whether we are in the middle of a table ("T") at the end of a table ("L") or
  // beyond the end of the table (" ").
gjsTree.fnSetImage = function(oImage,sMore) {
  //
  var sNameProp
  //
  sNameProp=gjsTree.fnGetNameProp(getAttr(oImage,"src"))
  //
  // In the middle of a table
  if (sMore=="T") {
    if (sNameProp=='vcm_plus_tbr.gif') {setAttr(oImage,"src","vcm_plus_tbr.gif"); return}
    if (sNameProp=='vcm_working_tbr.gif') {setAttr(oImage,"src","vcm_working_tbr.gif"); return}
    if (sNameProp=='vcm_minus_tbr.gif') {setAttr(oImage,"src","vcm_minus_tbr.gif"); return}
    if (sNameProp=='vcm_plus_tr.gif') {setAttr(oImage,"src","vcm_plus_tbr.gif"); return}
    if (sNameProp=='vcm_working_tr.gif') {setAttr(oImage,"src","vcm_working_tbr.gif"); return}
    if (sNameProp=='vcm_minus_tr.gif') {setAttr(oImage,"src","vcm_minus_tbr.gif"); return}
    if (sNameProp=='vcm_l.gif') {setAttr(oImage,"src","vcm_t.gif"); return}
    if (sNameProp=='vcm_t.gif') {setAttr(oImage,"src","vcm_t.gif"); return}
    if (sNameProp=='vcm_blank.gif') {setAttr(oImage,"src","vcm_i.gif"); return} // sic vcm_i.gif
  }
  //
  // Last row in a table
  if (sMore=="L") {
    if (sNameProp=='vcm_plus_tbr.gif') {setAttr(oImage,"src","vcm_plus_tr.gif"); return}
    if (sNameProp=='vcm_working_tbr.gif') {setAttr(oImage,"src","vcm_working_tr.gif"); return}
    if (sNameProp=='vcm_minus_tbr.gif') {setAttr(oImage,"src","vcm_minus_tr.gif"); return}  
    if (sNameProp=='vcm_plus_tr.gif') {setAttr(oImage,"src","vcm_plus_tr.gif"); return}
    if (sNameProp=='vcm_working_tr.gif') {setAttr(oImage,"src","vcm_working_tr.gif"); return}
    if (sNameProp=='vcm_minus_tr.gif') {setAttr(oImage,"src","vcm_minus_tr.gif"); return}  
    if (sNameProp=='vcm_l.gif') {setAttr(oImage,"src","vcm_l.gif"); return}
    if (sNameProp=='vcm_t.gif') {setAttr(oImage,"src","vcm_l.gif"); return}
    if (sNameProp=='vcm_blank.gif') {setAttr(oImage,"src","vcm_l.gif"); return}
  }
  //
  // Beyond the end of a table
  if (sMore==" ") {
    setAttr(oImage,"src","vcm_blank.gif"); return
  }
}


  // Get filename from src property of image (which contains full url when read)
  // Equivalent to the IE only sNameProp property
gjsTree.fnGetNameProp = function(sSrc) {
  return sSrc.substr(sSrc.lastIndexOf("/")+1)
}


  // Generate a list of more flags based on the icons to the left of the current cell.
  // Iterate through the preceding cells and based on the image return the appropriate
  // more flag.
  // This is called when a +/- icon is clicked.  The result is passed to the server
  // along with the request for a sub-table and returned (with one additional column)
  // as part of the response.
  // This is then used by the style sheet to generate the appropriate markup.
  //
gjsTree.fnMores = function(oCell) {
  //
  var sMores
  //
  sMores=""
  //
  while (oCell) {
	if (getAttr(oCell.childNodes,"src")) {
		sNameProp=gjsTree.fnGetNameProp(getAttr(oCell.childNodes[0],"src"))
		if (sNameProp=="vcm_plus_tbr.gif") sMores="I"+sMores
		if (sNameProp=="vcm_working_tbr.gif") sMores="I"+sMores
		if (sNameProp=="vcm_minus_tbr.gif") sMores="I"+sMores
		if (sNameProp=="vcm_plus_tr.gif") sMores=" "+sMores
		if (sNameProp=="vcm_working_tr.gif") sMores=" "+sMores
		if (sNameProp=="vcm_minus_tr.gif") sMores=" "+sMores
		if (sNameProp=="vcm_l.gif") sMores="L"+sMores
		if (sNameProp=="vcm_i.gif") sMores="I"+sMores
		if (sNameProp=="vcm_t.gif") sMores="T"+sMores
		if (sNameProp=="vcm_blank.gif") sMores=" "+sMores
	}
    oCell=oCell.previousElementSibling
  }
  return sMores
}


gjsTree.fnDeleteRows = function(sourceDivId,oResults) {
  //
  var oDivRowDelete,i,targetRowId,oTargetBody,oTargetTable
  var oTargetCell,sMores
  //
  oDivRowDelete=oResults.getElementById(sourceDivId)
  if (!oDivRowDelete) return // Nothing to do
  //
  for (i=0; i<oDivRowDelete.childNodes.length; i++) {
    if (oDivRowDelete.childNodes[i].nodeName!="DELETE") continue
    targetRowId=oDivRowDelete.childNodes[i].attributes.getNamedItem("rowId").value
    oTargetBody=document.getElementById(targetRowId+"body")
    oTargetTable=oTargetBody.parentNode
    //
    // Get info for fnResetMores before we delete last row
    if (!sMores && !oTargetBody.nextElementSibling) {
      oTargetCell=document.getElementById(getAttr(oTargetBody,"gjsRowId")+'click')
      sMores=gjsTree.fnMores(oTargetCell)
    }
    //
    // Remove row
    oTargetTable.removeChild(oTargetBody)
  }
  //
  // Reset the continuation cells when we delete the last row in the table.
  // The reset updates more rows than necessary but it can be optimised some other time.
  if (sMores) gjsTree.fnResetMores(oTargetTable,sMores.length-1)

}


  // Update one or more rows within the target div using the serverLink results output
gjsTree.fnRefreshRows = function(targetDivId,oResults) {
  //
  var oSourceDiv,oSourceTable
  var oBody,oTargetBody,oTargetTable
  var oTargeticon,oTargetCell,sMores
	var oMain,lastRowId
  //
  oSourceDiv=oResults.getElementById(targetDivId)
  if (!oSourceDiv) return // No results to process
  // 
  // Clone the damn thing because it exists in the serverLink document and we need it here
  oSourceDiv=gjsTree.fnCloneNode(oSourceDiv)
  oSourceTable=oSourceDiv.children[1] // Skip the column header div
  //
  // Reset the selected cells array as all refreshed items will be reselected
	SelectedClass.selectedCells=new Array()
	//
  // Walk the tbodies (the insertBefore() method removes the tbodies from oSourceTable as they are processed)
	while (oSourceTable.tBodies.length) {
		oBody=oSourceTable.tBodies[0]
		//
		// If row has already been deleted (or is no longer present) then remove it from source tree
		if (typeof(getAttr(oBody,"gjsTargetRowId"))=="undefined") {
			oSourceTable.removeChild(oBody)
			continue
		}
    //
    oTargetBody=document.getElementById(getAttr(oBody,"gjsTargetRowId")+"body")
    oTargetTable=oTargetBody.parentNode
    //
    // Do it!
		oTargetTable.replaceChild(oBody,oTargetBody)
    //
		// Re-select the row
		oMain=fnElement(getAttr(oBody,"gjsRowId")+"main")
		Class.fnAddCellToSelection(oMain)
		//
		// Remember the last row that got refreshed
		lastRowId=getAttr(oBody,"gjsRowId")
	}
	//
  // Delete of a row (e.g. component delete) leaves lastRowId undefined
  if (typeof(lastRowId)!="undefined") {
    // Reset the continuation cells if possible
    // We only really need to reset the last cell in the current row.
    // We don't actually need to do this for every cell (vertically) in the the table, but 
    // it can be optimised some other time.
    sMores=gjsTree.fnMores(document.getElementById(lastRowId+'click').previousElementSibling)
    gjsTree.fnResetMores(oTargetTable,sMores.length)
    //
    // Always resize columns because some browsers (e.g. Chrome) apparently don't propagate td widths down across tbody sections
    gjsTree.fnResizeColumns(oTargetTable.id,getAttr(oTargetTable,"gjsReferenceHeadingId"))
  }
}


  // Clone a document tree fragment from some other document to this document
  // If you don't do this you will get unexpected errors when using dom methods like appendNode() and
  // insertBefore().
gjsTree.fnCloneNode = function(oTree) {
  //
  var sTree,oNewTree
  //
  // Serialise it
  sTree=oTree.outerHTML
  //
  // Recreate it 'here'
  oNewTree=document.createElement('div')
  oNewTree.innerHTML=sTree
  //
  return oNewTree.childNodes[0]
}


	// Set the main heading div to the content of the hidden reference div
gjsTree.fnSetMainHead = function(sMainHead) {
  document.getElementById('divMainHead').innerHTML=document.getElementById(sMainHead).innerHTML;
}


	// When a div is scrolled horizontally, scroll the corresponding heading by the same amount
gjsTree.fnScrollHeading = function(divMain,divHead) {
  //
  var oDivMain=document.getElementById(divMain)
  var oDivHead=document.getElementById(divHead)
  //
	oDivHead.style.clip="rect(auto auto auto " + oDivMain.scrollLeft + "px)"
	oDivHead.style.left=(oDivMain.scrollLeft*-1)
}


  // Bulletproof method for stopping events from bubbling
gjsTree.fnEventStop = function(e) {
	var evt = e ? e:window.event;
	evt.keyCode=0; // Required to stop F5 key
	evt.returnValue=false;
	evt.cancelBubble=true;
	if (evt.preventDefault) evt.preventDefault();
	if (evt.stopPropagation) evt.stopPropagation();
	evt.returnValue = false;
	return false;
}


	// Public - Return the object id (not the oref) of the first element within a tree that has a specified attribute value
	// (does not search style attributes)
gjsTree.fnFind = function(element,attribute,value) {
	//
	// Inputs:
	//   element - the root element from which to start searching
	//   attribute - the name of the attribute to search for
	//   value - the value to search for in the specified attribute
	// Outputs
	//   gjsTree.fnFind - returns a string containing the id of the *first* element that has a matching attribute
	//
	var childNodes,i,foundId
	//
	// Does this element match the search criterion?
	if (element[attribute]==value) return element.id
	//
	// Now process the child nodes of this node
	childNodes = element.childNodes
	for (i=0; i<childNodes.length; i++) {
		//
		// If the node is an ELEMENT then process it recursively...
		if (childNodes[i].nodeType == 1) {
			var foundId = gjsTree.fnFind(childNodes[i],attribute,value)
			if (foundId != null) return foundId
		}
	}
	return null
}
