<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
	<xsl:apply-templates select="namespaces"/>
</xsl:template>

<xsl:template match="/Form/namespaces">

<gjs:form
 title='Add Namespaces'
 jsFile='vcmNamespaceWizard_Form.js'
 save='no'
 close='no'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

	<gjs:information>
		Use this wizard to start managing code in namespaces that are not yet controlled by Deltanji.&nbsp; Check the box
    alongside each namespace you want to add.&nbsp; Use the 'Help' button to learn more about what will happen when you click 'OK'.
	</gjs:information>

<div id='divNamespaces' class='visible'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='100'/>
    <gjs:column width='290'/>
  </gjs:columnWidths>

  <gjs:fields>

    <tr valign="top">
      <gjs:caption>
        <label>
          Namespaces
        </label>
      </gjs:caption>
      <td>
        <div class='gridTableOuter' style='min-height: 200px; width: 305px;'>
          <table class='formLayoutTable'>
          </table>
          <div class='gridTableInner' style='height: 200px;' id='divLocations'>
            <table class='formLayoutTable'>
              <tr>
                <gjs:column width='20'/>
                <gjs:column width='183'/>
              </tr>
              <xsl:apply-templates select="/Form/namespaces/namespace" mode='grid' />
            </table>
            <!-- Extra hidden namespace checkbox to guarantee an array even if only one namespace is available to be listed -->
            <input 
             type='checkbox'
             name='namespace'
             style='display: none;'/>
          </div>
        </div>
      </td>
    </tr>

  </gjs:fields>
  </gjs:frame>
</div>
</gjs:form>

</xsl:template>

<xsl:template match='namespace' name='namespace' mode="grid">
  <tr
   class='row'
   title='Check the box to start managing code in this namespace when the wizard completes'>
    <xsl:if test='@canAdd="0"'>
      <xsl:attribute name='title'>Namespace cannot be selected until Deltanji global and routine mappings have been manually added to it via Portal</xsl:attribute>
    </xsl:if>
    <td style='width: 5%;'>
      <input 
       type='checkbox'
       name='namespace'
       accesskey='c'
       value='{@namespace}'
       onclick='Form.fnChanged()'>
      <xsl:if test='@canAdd="0"'>
        <xsl:attribute name='disabled'>disabled</xsl:attribute>
        <xsl:attribute name='class'>inputDisabled</xsl:attribute>
      </xsl:if>
      </input>
    </td>
    <td>
      <xsl:if test='@canAdd="0"'>
        <xsl:attribute name='style'>color: red;</xsl:attribute>
      </xsl:if>
      <xsl:value-of select='@namespace'/>
    </td>
  </tr>
</xsl:template>

</xsl:stylesheet>
