//vc/ Deltanji bulk transfer
//vc/ Copyright 2016 George James Software
//vc/ Object:    vcmObject_BulkTransfer.js/1
//vc/ Component: vcmObject_BulkTransfer.js

	var delimiter=parent.opener.delimiter;
	var winHelpProperties = parent.opener.winHelpProperties;

	// Initialise form
function fnLoad() {
  
	//fnFormDisable(frmMain);
  Form.fnAutoSize();
	// Get the route dropdowns ready
	fnPrepareFunctionList();
	fnPrepareFromLocationList();
	fnPrepareToLocationList();
	
	// If we originally didn't discover any from-locations, see if the to-location discovery means we can now find a from-location
	if (frmMain.txtLcode1.options.length<2) fnPrepareFromLocationList();

	// Prepare filename fields now we've prepared the location lists
	fnPrepareFromFilename();
	fnPrepareToFilename();

	frmMain.txtFunction.focus();
}


	// Disable the form fields and put up an hourglass
function fnFormDisable(form) {
	form.className='frmWait';
  
  $(":input").not("[class|='scombobox']").each( function() {
    $(this).attr("gjsOldDisabled",$(this).prop("disabled"));
    $(this).prop("disabled",true);
  }
  )
  $(".scombobox").each( function() {
    $(this).attr("gjsOldDisabled",$(this).prop("disabled"));
    $(this).prop("disabled",true);
  }
  )
}


	// Enable the form and restore the cursor
function fnFormEnable(form) {
	form.className='frmNormal';
  
  $(":input").not("[class|='scombobox']").each( function() {
    $(this).prop("disabled", function() {
      return ($(this).attr("gjsOldDisabled")=='true');
    }
    );
  }
  )
  $(".scombobox").each( function() {
    $(this).prop("disabled", function() {
      return ($(this).attr("gjsOldDisabled")=='true');
    }
    );
  }
  )
}

	//----------------------------------------------------------------------
	// Validate and save item
	//----------------------------------------------------------------------
function fnItemSaveClose() {
  fnFormDisable(frmMain)
	parent.serverLink.fnDo('fnItemSaveCloseResult','Object.BulkTransfer.fnTransfer',fnArguments());
}

	// When a transfer has completed we need to append the new audit message table rows to the
	// existing audit table
	//
function fnItemSaveCloseResult(oResult) {
	//
	var bErrors
	//
	// Report any errors
	bErrors=fnReportErrors(oResult)
	//
	// If there were any audit messages then write them to the message panel
	if (oResult.getElementById('divMainBody')) parent.opener.AuditTrail.fnAppendMessages(oResult)
	//
	// If there were errors re-enable controls, else close the window
	if (bErrors) {
    fnFormEnable(frmMain);
    frmMain.cmdOK.focus();
  } else {
    parent.fnClose();
  }
}

	// Report error(s) in simple alert box(es)
function fnReportErrors(oResult) {
	var oXml,oXMLDocument,cNodes,i
	oXml=oResult.getElementById('xErrors')
	if (!oXml) return false
  
  // We have to use outerHTML and the /script prefix because on Firefox innerHTML returns "" in this situation
  oXMLDocument=$.parseXML(oXml.outerHTML)
	cNodes=$(oXMLDocument).xpath('/script/errors/message')
	if (cNodes.length==0) return false
	for (i=0; i<cNodes.length; i++)	{
		// Message may contain literal \n that needs to be converted
		alert(cNodes[i].getAttribute('message').replace(/\\n/g,'\n'))
	}
        return true
}


function fnArguments() {
	var arguments;
	var i;
	var selected;
	//
	arguments  = frmMain.txtFunction.value;
	arguments += delimiter + frmMain.txtLcode1.value;
  if (frmMain.txtFile1.style.visibility=='visible') arguments += ':' + frmMain.txtFile1.value;
	arguments += delimiter + frmMain.txtLcode2.value;
  if (frmMain.txtFile2.style.visibility=='visible') arguments += ':' + frmMain.txtFile2.value;
	for (i=0; i<2; i++) {
		if (frmMain.allitems[i].checked==true) arguments += delimiter + frmMain.allitems[i].value;
	}
	arguments += delimiter;
  if (frmMain.allitems[1].checked) {
  	for (i=0; i<frmMain.oldselectors.length; i++) {
  		if (frmMain.oldselectors[i].value!="") {
  			arguments += frmMain.oldselectors[i].value;
  			arguments += '\002';
  		}
  	}
  }	
	arguments += delimiter;
  arguments += (frmMain.background.checked==true)?1:0;
	//
	return arguments;
}


function fnHelp() {
	winHelp=window.open('WebDoc/docs/bulktransfer.html','vcmHelp',winHelpProperties) ;
	winHelp.focus();
}


  // Show/hide the From-loc filename field
function fnPrepareFromFilename() {
  if (fnGetFilePromptAttribute(frmMain.txtLcode1)=='1') {
    frmMain.txtFile1.style.visibility='visible';
  }
  else {
    frmMain.txtFile1.style.visibility='hidden';
  }
}

  // Show/hide the To-loc filename field
function fnPrepareToFilename() {
  if (fnGetFilePromptAttribute(frmMain.txtLcode2)=='1') {
    frmMain.txtFile2.style.visibility='visible';
  }
  else {
    frmMain.txtFile2.style.visibility='hidden';
  }
}

	// Set function list
function fnPrepareFunctionList() {
	var sFunction=fnGetChoice(frmMain.txtFunction);
	var sFromLocation=fnGetChoice(frmMain.txtLcode1);
	var sToLocation=fnGetChoice(frmMain.txtLcode2);
	var sToLClass='';
	var cAllNodes;
	var cNodes=null;
	var oOption;
	var sValue;
	var aSeen = new Array(); // Used to remove duplicates (haven't worked out how to do this in selectNodes)
	var i;
  var oXMLDocument=$.parseXML(xRoutes.innerHTML)
	
	if (sToLocation.slice(0,1)=='@') {
		sToLClass=sToLocation.slice(1);
		sToLocation='';
	}

	cAllNodes=$(oXMLDocument).xpath('/routes/function');
	

	if (sFromLocation!='') {
		if (sToLocation!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[fromlocation[tolocation/@location="'+sToLocation+'" or tolocation/@location="%ANY"]/@location="'+sFromLocation+'" or fromlocation[tolocation/@location="'+sToLocation+'" or tolocation/@location="%ANY"]/@location="%ANY"]');
		}
		else if (sToLClass!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[fromlocation[tolocationclass/@locationclass="'+sToLClass+'"]/@location="'+sFromLocation+'" or fromlocation[tolocationclass/@locationclass="'+sToLClass+'"]/@location="%ANY"]');
		}
		else {
			cNodes=$(oXMLDocument).xpath('/routes/function[fromlocation/@location="'+sFromLocation+'" or fromlocation/@location="%ANY"]');
		}
	}
	else if (sToLocation!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[fromlocation/tolocation/@location="'+sToLocation+'" or fromlocation/tolocation/@location="%ANY"]');
	}
	else if (sToLClass!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[fromlocation/tolocationclass/@locationclass="'+sToLClass+'"]');
	}
	
	
	frmMain.txtFunction.options.length=0;
	oOption=document.createElement('OPTION');
	oOption.text='                                        '; //40 spaces for width
	oOption.value='';
	oOption.selected=true;
	frmMain.txtFunction.add(oOption);
	
	if (cNodes!=null) {
		for (i=0; i<cNodes.length; i++) {
			sValue=cNodes[i].getAttribute('function');
			if (typeof(aSeen[sValue])=='undefined') {
				aSeen[sValue]='';
				oOption=document.createElement('OPTION');
				oOption.text=cNodes[i].getAttribute('title');
				oOption.value=sValue;
				oOption.selected=(sValue==sFunction);
				frmMain.txtFunction.add(oOption);
			}
		}
		if ((cNodes.length>0) && (aSeen.length<cAllNodes.length)) {
			oOption=document.createElement('OPTION');
			oOption.text='   -- Other functions --';
			oOption.value='';
			oOption.style.backgroundColor='lightgrey';
			frmMain.txtFunction.add(oOption);
		}
	}
	
	for (i=0; i<cAllNodes.length; i++) {
		sValue=cAllNodes[i].getAttribute('function');
		if (typeof(aSeen[sValue])=='undefined') {
			oOption=document.createElement('OPTION');
			oOption.text=cAllNodes[i].getAttribute('title');
			oOption.value=sValue;
			oOption.selected=(sValue==sFunction);
			frmMain.txtFunction.add(oOption);
		}
	}
}

	// Bespoke sort function for lcode/lclass lists
function fnLocSort(a, b) {
    var textA = a[0];
    var textB = b[0];
    return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
}

	// Set from-loc list
function fnPrepareFromLocationList() {
	var sFunction=fnGetChoice(frmMain.txtFunction);
	var sFromLocation=fnGetChoice(frmMain.txtLcode1);
	var sToLocation=fnGetChoice(frmMain.txtLcode2);
	var sToLClass='';
	var cNodes;
	var oOption;
	var sValue;
	var bListAll;
	var aSeen = new Array(); // Used to remove duplicates (haven't worked out how to do this in selectNodes)
	var aSortable = new Array(); // Used to sort the results
	var i;
	var oXMLDocument=$.parseXML(xRoutes.innerHTML)
  
	if (frmMain.txtLcode1.disabled) return;
	
	if (sToLocation.slice(0,1)=='@') {
		sToLClass=sToLocation.slice(1);
		sToLocation='';
	}

	if (sFunction!='') {
		if (sToLocation!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation[tolocation/@location="'+sToLocation+'" or tolocation/@location="%ANY"]');
		}
		else if (sToLClass!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation[tolocationclass/@locationclass="'+sToLClass+'"]');
		}
		else {
			cNodes=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation');
		}
	}
	else {
		cNodes=$(oXMLDocument).xpath('/routes/function/fromlocation');
	}
		
	frmMain.txtLcode1.options.length=0;
	oOption=document.createElement('OPTION');
	oOption.text='                                        '; //40 spaces for width
	oOption.value='';
	oOption.selected=true;
	frmMain.txtLcode1.add(oOption);
	bListAll=false;
	for (i=0; i<cNodes.length; i++) {
		if (cNodes[i].getAttribute('location')=='%ANY') {
			bListAll=true;
			break;
		}
	}
	if (bListAll) {
		fnAddAllLocations(frmMain.txtLcode1,sFromLocation,'from');
	}
	else {
		aSeen=[];
		for (i=0; i<cNodes.length; i++) {
			sValue=cNodes[i].getAttribute('location');
			aSeen[sValue]=i;
		}
		aSortable=[];
		for (sValue in aSeen) aSortable.push([sValue, aSeen[sValue]]);
		aSortable.sort(fnLocSort);
		
		for (i=0; i<aSortable.length; i++) {
			sValue=aSortable[i][0];
			oOption=document.createElement('OPTION');
			oOption.text=sValue;
			oOption.value=sValue;
			setAttr(oOption,'gjsFilePrompt',cNodes[aSortable[i][1]].getAttribute('fileprompt'));
			if (sValue==sFromLocation) {
				oOption.selected=true;
			}
			frmMain.txtLcode1.add(oOption);
		}
	}
	if (frmMain.txtLcode1.options.length==2) {
		frmMain.txtLcode1.selectedIndex=1;
	}
}

	// Set to-loc list (includes lists, formerly called classes)
function fnPrepareToLocationList() {
	var sFunction=fnGetChoice(frmMain.txtFunction);
	var sFromLocation=fnGetChoice(frmMain.txtLcode1);
	var sToLocation=fnGetChoice(frmMain.txtLcode2);
	var cNodes;
	var cNodesClasses;
	var oOption;
	var sValue;
	var bListAll;
	var aSeen = new Array(); // Used to remove duplicates (haven't worked out how to do this in selectNodes)
	var aSortable = new Array(); // Used to sort the results
	var i;
	var iMembers;
  var oXMLDocument=$.parseXML(xRoutes.innerHTML)

	if (sFunction!='') {
		if (sFromLocation!='') {
			cNodes=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation[@location="'+sFromLocation+'" or @location="%ANY"]/tolocation');
			cNodesClasses=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation[@location="'+sFromLocation+'" or @location="%ANY"]/tolocationclass');
		}
		else {
			cNodes=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation/tolocation');
			cNodesClasses=$(oXMLDocument).xpath('/routes/function[@function="'+sFunction+'"]/fromlocation/tolocationclass');
		}
	}
	else {
		cNodes=$(oXMLDocument).xpath('/routes/function/fromlocation/tolocation');
		cNodesClasses=$(oXMLDocument).xpath('/routes/function/fromlocation/tolocationclass');
	}

	frmMain.txtLcode2.options.length=0;
	oOption=document.createElement('OPTION');
	oOption.text='                                        '; //40 spaces for width
	oOption.value='';
	oOption.selected=true;
	frmMain.txtLcode2.add(oOption);
	bListAll=false;
	for (i=0; i<cNodes.length; i++) {
		if (cNodes[i].getAttribute('location')=='%ANY') {
			bListAll=true;
			break;
		}
	}
	if (bListAll) {
		fnAddAllLocations(frmMain.txtLcode2,sToLocation,'to');
	}
	else {
		aSeen=[];
		for (i=0; i<cNodes.length; i++) {
			sValue=cNodes[i].getAttribute('location');
			aSeen[sValue]=i;
		}
		aSortable=[];
		for (sValue in aSeen) aSortable.push([sValue, aSeen[sValue]]);
		aSortable.sort(fnLocSort);
		
		for (i=0; i<aSortable.length; i++) {
			sValue=aSortable[i][0];
			oOption=document.createElement('OPTION');
			oOption.text=sValue;
			oOption.value=sValue;
			setAttr(oOption,'gjsFilePrompt',cNodes[aSortable[i][1]].getAttribute('fileprompt'));
			if (sValue==sToLocation) {
				oOption.selected=true;
			}
			frmMain.txtLcode2.add(oOption);
		}
	}
	if (frmMain.txtLcode2.options.length==2) {
		frmMain.txtLcode2.selectedIndex=1;
	}
	if (cNodesClasses.length>0) {
		oOption=document.createElement('OPTION');
		oOption.text='    -- Lists --';
		oOption.value='';
		oOption.style.backgroundColor='lightgrey';
		frmMain.txtLcode2.add(oOption);
		aSeen=[];
		for (i=0; i<cNodesClasses.length; i++) {
			sValue=cNodesClasses[i].getAttribute('locationclass');
			aSeen[sValue]=i;
		}
		aSortable=[];
		for (sValue in aSeen) aSortable.push([sValue, aSeen[sValue]]);
		aSortable.sort(fnLocSort);
		
		for (i=0; i<aSortable.length; i++) {
			sValue=aSortable[i][0];
			iMembers=cNodesClasses[aSortable[i][1]].getAttribute('members');
			oOption=document.createElement('OPTION');
			oOption.text=sValue+'  ('+iMembers+' location'+((iMembers>1)?'s':'')+')';
			oOption.value='@'+sValue;
			setAttr(oOption,'gjsFilePrompt','0');
			oOption.selected=(oOption.value==sToLocation);
			frmMain.txtLcode2.add(oOption);
		}
	}
}

	// Put all locations with sTestAttribute='1' into SELECT el and preselect sLocation if found
function fnAddAllLocations(el,sLocation,sTestAttribute) {
	var cNodes;
	var i;
	var sValue;
	var oOption;
  var oXMLDocument=$.parseXML(xRoutes.innerHTML)

	cNodes=$(oXMLDocument).xpath('/routes/alllocations/location');
	for (i=0; i<cNodes.length; i++) {
		sValue=cNodes[i].getAttribute('location');
		if (cNodes[i].getAttribute(sTestAttribute)=='1') {
  		oOption=document.createElement('OPTION');
  		oOption.text=sValue;
  		oOption.value=sValue;
  		setAttr(oOption,'gjsFilePrompt',cNodes[i].getAttribute('fileprompt'));
  		if (sValue==sLocation) {
  			oOption.selected=true;
  		}
  		el.add(oOption);
		}
	}
}


function fnGetChoice(oSel) {
	if (oSel.selectedIndex!=-1) {
		return oSel.options[oSel.selectedIndex].value;
	}
	return '';
}


function fnGetFilePromptAttribute(oSel) {
	if (oSel.selectedIndex!=-1) {
		return getAttr(oSel.options[oSel.selectedIndex],'gjsFilePrompt');
	}
	return '0';
}
