<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:import href='Selector.xsl'/>
<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="bulkTransfer"/>
</xsl:template>

<xsl:template match="bulkTransfer">

  <gjs:form
   title='Bulk Transfer of Objects'
   width='590'
   jsFile='vcmObject_BulkTransfer.js'
   save='{/Form/@save}'
   close='{/Form/@close}'
   delete='no'
   print='{/Form/@print}'
   help='{/Form/@help}'
   ok='{/Form/@ok}'
   cancel='{/Form/@cancel}'
   onload='fnLoad()'>
 
    <script src='jquery.xpath.min.js'>
    </script>

    <xsl:copy-of select='/Form/island/node()' />
  
    <gjs:information>
      Transfer multiple objects between locations. 
    </gjs:information>
  
    <br/>

    <div id='divTransfer'>
      <gjs:frame>
        <gjs:columnWidths>
          <gjs:column width='120'/>
          <gjs:column width='340'/>
        </gjs:columnWidths>
    
        <gjs:fields>
          <gjs:list1
           id='txtFunction'
           accesskey='U'
           value=''
           onchange='Form.fnChanged(); fnPrepareFromLocationList(); fnPrepareToLocationList(); fnPrepareToFilename(); if (txtLcode1.options.length&lt;2) fnPrepareFromLocationList(); fnPrepareFunctionList();'>
           <label>F<u>u</u>nction</label>
           <hint>Transfer function</hint>
          </gjs:list1>
      
          <tr>
            <gjs:list1
             id='txtLcode1'
             accesskey='F'
             value='{@from}'
             row='0'
             onchange='Form.fnChanged(); fnPrepareFromFilename(); fnPrepareFunctionList(); fnPrepareToLocationList();'>
              <xsl:if test="@from">
                <xsl:attribute name='disabled'>disabled</xsl:attribute>
              </xsl:if>
              <label><u>F</u>rom</label>
              <hint>Location to transfer objects from</hint>
              <xsl:if test="@from">
                <item>
                  <label><xsl:value-of select="@from" /></label>
                  <value><xsl:value-of select="@from" /></value>
                </item>
              </xsl:if>
            </gjs:list1>
            <td>
              <input class='input' title='For a sequential file location, enter the input filename' style='display: inline; visibility: hidden;' type='text' size='8' maxlength='40' id='txtFile1' />
            </td>
          </tr>
          
          <tr>
            <gjs:list1
             id='txtLcode2'
             accesskey='T'
             row='0'
             onchange='Form.fnChanged(); fnPrepareToFilename(); fnPrepareFunctionList(); fnPrepareFromLocationList();'>
               <label><u>T</u>o</label>
               <hint>Location or list to transfer objects to</hint>
            </gjs:list1>
            <td>
              <input class='input' title='For a sequential file location, optionally enter the output filename' style='display: inline; visibility: hidden;' type='text' size='8' maxlength='40' id='txtFile2' />
            </td>
          </tr>
            
          <tr>
            <td height='15'></td>
          </tr>
    	    <tr>
    				<td colspan='4'>
    		
         			<xsl:apply-templates select='/Form/selectors' />
    		
       			</td>
    	    </tr>
      
          <gjs:checkbox
           id='background'
           accesskey='B'>
           <label><u>B</u>ackground?</label>
           <hint>Check to perform the transfer in the background. Persistent audit messages will be recorded, but no messages will be presented to you during the transfer.</hint>
          </gjs:checkbox>
    
        </gjs:fields>
  
      </gjs:frame>
    </div>

  </gjs:form>
</xsl:template>

<!-- Location list boxes -->
<xsl:template match='location' mode="list1">
<item>
  <label><xsl:value-of select="@location" /></label>
  <value><xsl:value-of select="@location" /></value>
</item>
</xsl:template>

<!-- Object selector  -->
<xsl:template match='selectors'>
	<xsl:call-template name='gjs:selector'>
		<xsl:with-param name='chkAll' select='0' />
		<xsl:with-param name='labelIndent' select='0' />
		<xsl:with-param name='labelWidth' select='120' />
		<xsl:with-param name='location' select='/Form/bulkTransfer/@from' />
	</xsl:call-template>
</xsl:template> 

</xsl:stylesheet>
